<?php
//  ---------------------------------------------------------------------------------
//    _____   _             _                   _   _____
//   |  __ \ | |           | |    /\           (_) |  __ \
//   | |__) || |__    __ _ | |   /  \    _ __   _  | |__) |_ __  ___
//   |  ___/ | '_ \  / _` || |  / /\ \  | '_ \ | | |  ___/| '__|/ _ \
//   | |     | | | || (_| || | / ____ \ | |_) || | | |    | |  | (_) |
//   |_|     |_| |_| \__,_||_|/_/    \_\| .__/ |_| |_|    |_|   \___/
//                                      | |
//                                      |_|
//   PhalApi Pro 专业版
//   广州果创网络科技有限公司
//
//  ---------------------------------------------------------------------------------
//
//   一、协议的许可和权利
//    1. 您可以在完全遵守本协议的基础上，将本软件应用于商业用途；
//    2. 您可以在协议规定的约束和限制范围内修改本产品源代码或界面风格以适应您的要求；
//    3. 您拥有使用本产品中的全部内容资料、商品信息及其他信息的所有权，并独立承担与其内容相关的
//       法律义务；
//    4. 获得商业授权之后，您可以将本软件应用于商业用途，自授权时刻起，在技术支持期限内拥有通过
//       指定的方式获得指定范围内的技术支持服务；
//
//   二、协议的约束和限制
//    1. 未获商业授权之前，禁止将本软件用于商业用途（包括但不限于企业法人经营的产品、经营性产品
//       以及以盈利为目的或实现盈利产品）；
//    2. 未获商业授权之前，禁止在本产品的整体或在任何部分基础上发展任何派生版本、修改版本或第三
//       方版本用于重新开发；
//    3. 如果您未能遵守本协议的条款，您的授权将被终止，所被许可的权利将被收回并承担相应法律责任；
//
//   三、有限担保和免责声明
//    1. 本软件及所附带的文件是作为不提供任何明确的或隐含的赔偿或担保的形式提供的；
//    2. 用户出于自愿而使用本软件，您必须了解使用本软件的风险，在尚未获得商业授权之前，我们不承
//       诺提供任何形式的技术支持、使用担保，也不承担任何因使用本软件而产生问题的相关责任；
//    3. 广州果创网络科技有限公司不对使用本产品构建的商城中的内容信息承担责任，但在不侵犯用户隐
//       私信息的前提下，保留以任何方式获取用户信息及商品信息的权利；
//
//   有关本产品最终用户授权协议、商业授权与技术服务的详细内容，均由广州果创网络科技有限公司独家
//   提供。广州果创网络科技有限公司拥有在不事先通知的情况下，修改授权协议的权力，修改后的协议对
//   改变之日起的新授权用户生效。电子文本形式的授权协议如同双方书面签署的协议一样，具有完全的和
//   等同的法律效力。您一旦开始修改、安装或使用本产品，即被视为完全理解并接受本协议的各项条款，
//   在享有上述条款授予的权力的同时，受到相关的约束和限制。协议许可范围以外的行为，将直接违反本
//   授权协议并构成侵权，我们有权随时终止授权，责令停止损害，并保留追究相关责任的权力。
//
//  ---------------------------------------------------------------------------------

namespace App\Common;

use Base\Common\Context;
use Base\Domain\Apps;
use Base\Domain\RequestLimitLog;
use Base\Domain\User;
use Base\Domain\User as UserDomain;
use PhalApi\Exception\BadRequestException;

/**
 * 针对开放接口的第二套接口签名方案
 *
 * - 基于动态参数的加密签名
 *
 * @author dogstar 20200429
 */
class SignFilter extends Filter {

    /**
     * 基于每次请求的动态参数，进行签名验证。与access_token不同的是，access_token是提前申请一次，然后使用。
     */
    public function check() {
        $di = \PhalApi\DI();
        
        // 前置检测：判断命名空间
        $this->checkNamespace();

        $uid = $di->request->get('uid'); // HACK：当前顾客ID是由应用指定，如果需要增加判断可自行调整
        $app_key = $di->request->get('app_key');
        
        // 调试模式下不进行后置检测
        if ($di->debug) {
            // 调试模式时手动指定
            if ($uid !== NULL) {
                $di->context->setUid($uid);
            }
            if ($app_key !== NULL) {
                $di->context->setAppKey($app_key);
            }
            return;
        }

        // 取全部参数
        $allParams = $di->request->getAll();
        $sign = isset($allParams['sign']) ? $allParams['sign'] : '';
        unset($allParams['sign']);


        $appsDomain = new Apps();
        $appInfo = $appsDomain->getApp($app_key);
        if (!$appInfo) {
            throw new BadRequestException(\PhalApi\T("application failed, app_key does not exist"));
        }
        if ($appInfo['app_status'] != 1) {
            throw new BadRequestException(\PhalApi\T("application failed, app has been unregistered or disabled"));
        }
        if ($appInfo['verify_status'] != 1) {
            throw new BadRequestException(\PhalApi\T("application failed, app approval failed"));
        }

        $expectSign = $this->encryptAppKey($allParams, $appInfo['app_secret']);

        if ($expectSign != $sign) {
            $di->logger->debug('wrong sign', array('sign' => $sign, 'need_sign' => $expectSign));
            throw new BadRequestException(\PhalApi\T("wrong sign"));
        }

        // 核心检测：基于JWT的令牌检测
        $key = $di->config->get('app.jwt.key');
        $decodedArray = array();
                
        // 刷新上下文信息
        $di->context = new Context($app_key, $uid);

        // 后置判断

        $this->checkAppLimit();
        
        // 后置判断：检测app_key接口权限
        $this->checkAppRights();
        
        // 后置判断：检测用户状态
        $this->checkUserActive();
    }
    
    /**
     * 加密算法
     * 1、全部参数（排除sign），按key进行字典排序
     * 2、全部参数值，把原始值按字符串进行拼接，并在最后加上app_secret密钥
     * 3、对第2步结果，拼接密钥后，进行MD5加密
     * 4、对第3步结果，转成大写，得到sign签名（32位）
     */
    protected function encryptAppKey($params, $appSecrect) {
        ksort($params);

        $paramsStrExceptSign = '';
        foreach ($params as $val) {
            $paramsStrExceptSign .= $val;
        }

        return strtoupper(md5($paramsStrExceptSign . $appSecrect));
    }
}
